searchNodes=[{"doc":"Ets table backed by a persistence file. The table is persisted using the :ets.file2tab/2 and :ets.tab2file/3 functions. Table is to be created with PersistentEts.new/3 in place of :ets.new/2 . After that all functions from :ets can be used like with any other table, except :ets.give_away/3 and :ets.delete/1 - replacement functions are provided in this module. The :ets.setopts/2 function to change the heir is not supported - the heir setting is leveraged by the persistence mechanism. Like with regular ets table, the table is destroyed once the owning process (the one that called PersistentEts.new/3 ) dies, but the table data is persisted so it will be re-read when table is opened again. Example pid = spawn ( fn -&gt; :foo = PersistentEts . new ( :foo , &quot;table.tab&quot; , [ :named_table ] ) :ets . insert ( :foo , [ a : 1 ] ) end ) Process . exit ( pid , :diediedie ) PersistentEts . new ( :foo , &quot;table.tab&quot; , [ :named_table ] ) [ a : 1 ] = :ets . tab2list ( :foo )","ref":"PersistentEts.html","title":"PersistentEts","type":"module"},{"doc":"Deletes the entire table table . See :ets.delete/1 for more information.","ref":"PersistentEts.html#delete/1","title":"PersistentEts.delete/1","type":"function"},{"doc":"Synchronously dumps the table table to disk. This can be used to make sure all changes have been persisted, before continuing. The persistence loop will be restarted.","ref":"PersistentEts.html#flush/1","title":"PersistentEts.flush/1","type":"function"},{"doc":"Make process pid the new owner of table . If successful, message {:&quot;ETS-TRANSFER&quot;, table, manager_pid, data} is sent to the new owner. This behaviour differs slightly from the behaviour of :ets.give_away/3 , where the pid in the transfer message is the pid of the process giving the table away. This is not maintained, because the table manager process needs to keep track of the owner. The old owner is unlinked from the manager process and the new onwer is linked. See :ets.give_away/3 for more information.","ref":"PersistentEts.html#give_away/3","title":"PersistentEts.give_away/3","type":"function"},{"doc":"Creates a new table backed by the file path . Starts a &quot;table manager&quot; process responsible for periodically persisting the table to the file path and links the caller to the process. Tries to re-read the table from the persistence file. If no such file exists, a new table is created. Since options a table was created with are persisted alongside the table data, if the options the table was created with differ from the current options an error occurs. It's advised to manually transfer the data to the new table, with new options, if a change if options is needed. If the table was created with extended info, it will be read using the verify option. For information on what this means, refer to :ets.file2tab/2 . Changing the :heir option on the returned table is not supported, since it's leveraged by the persistence mechanism for correct operation. Options :path (required) - where to store the table file, :persist_every - how often to write the table to the file in milliseconds (default: 5_000), :persist_opts - options passed to :ets.tab2file/3 when saving the table For other options refer to the :ets.new/2 documentation. The :heir option is not supported as it's leveraged by the persistence system to guarantee the best possible durability. The :private option is not supported since the manager process needs access to the table in order to save it to the file.","ref":"PersistentEts.html#new/3","title":"PersistentEts.new/3","type":"function"},{"doc":"","ref":"PersistentEts.html#t:access/0","title":"PersistentEts.access/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:option/0","title":"PersistentEts.option/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:persist_opt/0","title":"PersistentEts.persist_opt/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:persistence/0","title":"PersistentEts.persistence/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:tab/0","title":"PersistentEts.tab/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:tweaks/0","title":"PersistentEts.tweaks/0","type":"type"},{"doc":"","ref":"PersistentEts.html#t:type/0","title":"PersistentEts.type/0","type":"type"},{"doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Documentation update","ref":"changelog.html#0-2-2-09-08-2021","title":"Changelog - 0.2.2 (09.08.2021)","type":"extras"},{"doc":"Bug fixes Fix PersistentEts.new/3 (broken since 0.2.0 ).","ref":"changelog.html#0-2-1-14-08-2019","title":"Changelog - 0.2.1 (14.08.2019)","type":"extras"},{"doc":"Changes Use DynamicSupervisor instead of :simple_one_for_one and migrate to the Elixir 1.5 child specs. Improve documentation.","ref":"changelog.html#0-2-0-02-08-2019","title":"Changelog - 0.2.0 (02.08.2019)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-02-03-2017","title":"Changelog - 0.1.0 (02.03.2017)","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"PersistentEts Ets table backed by a persistence file. The table is persisted using the :ets.file2tab/2 and :ets.tab2file/3 functions. Table is to be created with PersistentEts.new/3 in place of :ets.new/2 . After that all functions from :ets can be used like with any other table, except :ets.give_away/3 and :ets.delete/1 - replacement functions are provided in this module. The :ets.setopts/2 function to change the heir is not supported - the heir setting is leveraged by the persistence mechanism. Like with regular ets table, the table is destroyed once the owning process (the one that called PersistentEts.new/3 ) dies, but the table data is persisted so it will be re-read when table is opened again.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"pid = spawn ( fn -&gt; :foo = PersistentEts . new ( :foo , &quot;table.tab&quot; , [ :named_table ] ) :ets . insert ( :foo , [ a : 1 ] ) end ) Process . exit ( pid , :diediedie ) PersistentEts . new ( :foo , &quot;table.tab&quot; , [ :named_table ] ) [ a : 1 ] = :ets . tab2list ( :foo )","ref":"readme.html#example","title":"Overview - Example","type":"extras"},{"doc":"With Dets every operation (read or write) hits the disk. For many application such a performance penalty (compared to ets) is not acceptable. Furthermore Dets tables are limited to 2GB. Dets doesn't support the ordered_set table type either. With PersistentEts, the table remains in memory, so all read and write operations have the same performance they would have with pure Ets. Only periodically the table state is saved to a file. There's also no file limit, besides the memory and disk limitations. Since it's a regular Ets table, unlike with Dets, all types are fully supported.","ref":"readme.html#why-not-dets","title":"Overview - Why not Dets?","type":"extras"},{"doc":"The package can be installed by adding :persistent_ets to your list of dependencies in mix.exs : def deps do [ { :persistent_ets , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2017 Michał Muskała Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]